<?php

namespace App\Repository;

use App\Entity\CaseLocation;
use App\Entity\Location;
use App\Entity\MemberCase;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Persistence\ManagerRegistry;

/**
 * @extends ServiceEntityRepository<CaseLocation>
 */
class CaseLocationRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, CaseLocation::class);
    }

    public function getCaseLocations(MemberCase $case): array
    {
        return $this->createQueryBuilder('cl')
            ->leftJoin(Location::class, 'l', 'WITH', 'l.id = cl.location')
            ->andWhere('cl.memberCase = :case')
            ->setParameter('case', $case->getId()->toBinary())
            ->orderBy('l.name', 'ASC')
            ->getQuery()
            ->getResult()
        ;
    }

    //    /**
    //     * @return CaseLocation[] Returns an array of CaseLocation objects
    //     */
    //    public function findByExampleField($value): array
    //    {
    //        return $this->createQueryBuilder('c')
    //            ->andWhere('c.exampleField = :val')
    //            ->setParameter('val', $value)
    //            ->orderBy('c.id', 'ASC')
    //            ->setMaxResults(10)
    //            ->getQuery()
    //            ->getResult()
    //        ;
    //    }

    //    public function findOneBySomeField($value): ?CaseLocation
    //    {
    //        return $this->createQueryBuilder('c')
    //            ->andWhere('c.exampleField = :val')
    //            ->setParameter('val', $value)
    //            ->getQuery()
    //            ->getOneOrNullResult()
    //        ;
    //    }
}
